%define rev 32001

Name: chromium-browser
Version: 4.0.247.0
Release: alt1.r%rev.M41

Summary: An open source web browser developed by Google.
License: BSD
Group: Networking/WWW
Url: http://code.google.com/p/chromium/

Packager: Andrey Rahmatullin <wrar@altlinux.ru>

Source0: %name-%version.tar
Source1: %name.desktop
Source2: %name.default
Source3: %name.sh

Patch0: chromium-20091008-codechanges-system-libevent-nss-nspr-v8.patch
Patch1: chromium-20091111-alt-fedora-gyp-system-libevent-v8.patch
Patch2: chromium-20091111-alt-plugins-path.patch
# Use system libicu
#Patch7: chromium-20091111-alt-fedora-gyp-system-icu.patch
# Code changes to use system libicu
#Patch8: chromium-20090916-icu-code-changes.patch
# Revert this change to stop crashes
# http://src.chromium.org/viewvc/chrome/trunk/src/chrome/common/sqlite_utils.cc?r1=24321&r2=25633
Patch9: chromium-20090929-no-sqlite-debug.patch

%add_findreq_skiplist %_libdir/%name/xdg-settings

BuildPreReq: bzlib-devel flex gcc-c++ gperf libGConf-devel libXext-devel
BuildPreReq: libalsa-devel libevent1.4-devel libexpat-devel libgtk+2-devel
BuildPreReq: libjpeg-devel libnss-devel libv8-devel libxslt-devel
BuildPreReq: perl-Switch python-module-PyXML python-modules-compiler
BuildPreReq: python-modules-email python-modules-encodings python-modules-logging

%description
Chromium is an open-source browser project that aims to build a safer,
faster, and more stable way for all Internet users to experience the web.

%package codecs
Group: Networking/WWW
Summary: FFmpeg codecs for Chromium web browser
Requires: %name

%description codecs
Chromium is an open-source browser project that aims to build a safer,
faster, and more stable way for all Internet users to experience the web.

This package contains symlinks and package requirements necessary to
view HTML5 video in Chromium.

%prep
%setup

# Patch in code changes for system libs
%patch0 -p2
# Fix the gyp files for the bits we remove entirely
%patch1 -p1
%patch2 -p2
# Use system libicu
#%%patch7 -p1
# Code changes to use system libicu
#%%patch8 -p2
# Revert sqlite debugging to stop crashes
%patch9 -p2

echo 'ALT Linux, revision %rev' > build/LASTCHANGE.in

# Scrape out incorrect optflags and hack in the correct ones
PARSED_OPT_FLAGS=`echo \'%optflags -fno-strict-aliasing -fno-exceptions \' | sed "s/ /',/g" | sed "s/',/', '/g"`
for i in build/common.gypi; do
        sed -i "s|'-march=pentium4',||g" $i
        sed -i "s|'-msse2',||g" $i
        sed -i "s|'-mfpmath=sse',||g" $i
        sed -i "s|'-O<(debug_optimize)',||g" $i
        sed -i "s|'-m32',||g" $i
        sed -i "s|'-fno-exceptions',|$PARSED_OPT_FLAGS|g" $i
done


GYP_GENERATORS=make python build/gyp_chromium build/all.gyp \
	--depth=%_builddir/%name-%version \
	-D linux_sandbox_path=%_libdir/%name/%name-sandbox \
	-D linux_sandbox_chrome_path=%_libdir/%name/%name \
%ifarch x86_64
	-D target_arch=x64 \
%endif
	-D use_system_bzip2=1 \
	-D use_system_libjpeg=1 \
	-D use_system_libpng=1 \
	-D use_system_libxml=1 \
	-D use_system_libxslt=1 \
	-D use_system_zlib=1 \
	-D use_system_ffmpeg=1 \
	-D javascript_engine=v8

find . -name "*.mk" -exec sed -i -e 's/-Werror//g' {} \;



%build
%make_build BUILDTYPE=Release V=1 chrome chrome_sandbox

%install
pushd out/Release
install -pD -m755 chrome %buildroot%_libdir/%name/%name
install -p -m755 chrome_sandbox %buildroot%_libdir/%name/%name-sandbox
cp -a chrome.pak locales resources xdg-settings %buildroot%_libdir/%name/
install -pD -m644 chromium-browser.1 %buildroot%_man1dir/%name.1
popd

for i in 16 32 48 256; do
    install -pD -m644 chrome/app/theme/chromium/product_logo_$i.png \
        %buildroot%_iconsdir/hicolor/${i}x$i/apps/%name.png
done

install -pD -m644 %SOURCE1 %buildroot%_desktopdir/%name.desktop
install -pD -m644 %SOURCE2 %buildroot%_sysconfdir/%name/default
install -pD -m755 %SOURCE3 %buildroot%_bindir/%name
sed -i "s|/usr/lib/|%_libdir/|g" %buildroot%_bindir/%name

mkdir -p %buildroot%_libdir/%name/plugins/

rm -f %buildroot%_libdir/%name/locales/*.d
sed -i '1,2d' %buildroot%_man1dir/%name.1

for i in libavutil.so.49 libavformat.so.52 libavcodec.so.51; do
    ln -s ../$i %buildroot%_libdir/%name/
done

%files
%_bindir/%name
%_sysconfdir/%name/
%dir %_libdir/%name/
%_libdir/%name/%name
%attr(4711,root,root) %_libdir/%name/%name-sandbox
%_libdir/%name/chrome.pak
%_libdir/%name/locales/
%_libdir/%name/plugins/
%_libdir/%name/resources/
%_libdir/%name/xdg-settings
%_desktopdir/*.desktop
%_iconsdir/hicolor/*/apps/%name.png
%_man1dir/*
%doc AUTHORS LICENSE

%files codecs
%_libdir/%name/libav*.so.*

%changelog
* Sat Nov 28 2009 Yura Kalinichenko <yuk@kalina.in.ua>
- port to Branch 4.1.1

* Sat Nov 14 2009 Andrey Rahmatullin <wrar@altlinux.ru> 4.0.247.0-alt1.r32001
- r32001
- fix plugin search paths
- add revision info into the About dialog

* Fri Nov 13 2009 Andrey Rahmatullin <wrar@altlinux.ru> 4.0.246.0-alt1.r31782
- initial build for ALT Linux, based on Fedora spec and Ubuntu package

* Tue Oct 27 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.227.0-0.1.20091027svn30269
- 20091027svn30269
- apply hack fix to stop double free bug (http://code.google.com/p/chromium/issues/detail?id=23362)

* Tue Oct 13 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.222.6-0.1.20091013svn28872
- 20091013svn28872

* Thu Oct  8 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.222.2-0.1.20091008svn28391
- 20091008svn28391

* Wed Sep 30 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.220.0-0.1.20090930svn27599
- 20090930svn27599

* Tue Sep 29 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.219.8-0.1.20090929svn27489
- 20090929svn27489

* Wed Sep 16 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.212.0-0.1.20090916svn26424
- 20090916svn26424
- revert http://src.chromium.org/viewvc/chrome/trunk/src/chrome/common/sqlite_utils.cc?r1=24321&r2=25633
  to stop crashes when typing in url bar

* Thu Sep 10 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.208.0-0.1.20090910svn25958
- 20090910svn25958

* Wed Sep 9 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.208.0-0.1.20090909svn25824
- 20090909svn25824
- drop hardcoded Requires on bug-buddy (fixes issue where it is being obsoleted by abrt in rawhide)
- disable webkit deopt, flash bug is fixed now
- use system libicu

* Thu Aug 27 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.204.0-0.1.20090827svn24640
- 20090827svn24640

* Tue Aug 25 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.203.0-0.1.20090824svn24148
- 20090824svn24148
- find proper plugin dir on x86_64
- pass --enable-user-scripts (instead of old --enable-greasemonkey)

* Tue Aug 18 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.202.0-0.1.20090818svn23628
- 20090818svn23628

* Fri Aug 14 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.202.0-0.1.20090814svn23460
- 20090814svn23460

* Wed Aug 12 2009 Tom "spot" Callaway <tcallawa@redhat.com> 4.0.202.0-0.1.20090812svn23201
- Bump to 4.0.202 (we're not tracking 3.0, no one can tell me exactly how to manage that)

* Mon Aug 10 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.198.0-0.1.20090810svn22925
- 20090810svn22925

* Fri Aug  7 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.198.0-0.1.20090807svn22807
- 20090807svn22807

* Wed Aug  5 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.198.0-0.1.20090805svn22496
- 20090805svn22496

* Mon Aug  3 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.197.0-0.1.20090803svn22262
- 20090803svn22262

* Fri Jul 31 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.197.0-0.1.20090731svn22188
- 20090731svn22188

* Thu Jul 30 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.197.0-0.1.20090730svn22105
- 20090730svn22105

* Mon Jul 27 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.196.0-0.1.20090727svn21648
- 20090727svn21648

* Fri Jul 24 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.196.0-0.1.20090724svn21567
- 20090724svn21567
- drop ffmpeg binaries (only code remaining is headers, doesn't infringe patents)
- package up manpage

* Mon Jul 20 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.195.0-0.1.20090720svn21073
- 20090720svn21073

* Thu Jul 16 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.195.0-0.1.20090716svn20889
- 20090716svn20889

* Wed Jul 15 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.195.0-0.1.20090715svn20726
- 20090715svn20726

* Mon Jul 13 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.194.0-0.1.20090713svn20473
- 20090713svn20473

* Sat Jul 11 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.194.0-0.1.20090711svn20464
- 20090711svn20464
- fix sandboxing up to match code changes (no longer need to be read-only, doesn't need /var/run/chrome-sandbox)

* Wed Jul  8 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.193.0-0.1.20090708svn20141
- 20090708svn20141
- support LinuxZygote sandboxing

* Sat Jul  4 2009 Tom "spot" Callaway <tcallawa@redhat.com> 3.0.192.0-0.1.20090704svn19929
- 20090704svn19929
- hack in correct optflags

* Sun Jun 28 2009 Tom "spot" Callaway <tcallawa@redhat.com> 
- 20090628svn19474

* Fri Jun 26 2009 Tom "spot" Callaway <tcallawa@redhat.com>
- 20090626svn19370

* Thu Jun 25 2009 Tom "spot" Callaway <tcallawa@redhat.com> 
- 3.0.191.0 20090625svn19237

* Thu Jun 18 2009 Tom "spot" Callaway <tcallawa@redhat.com>
- 3.0.190.0 20090618svn18706

* Mon Jun 8 2009 Tom "spot" Callaway <tcallawa@redhat.com>
- 20090608svn17870

* Sat Jun 6 2009 Tom "spot" Callaway <tcallawa@redhat.com>
- 20090606svn17834
